#!/usr/bin/env python
#-*- coding:utf-8 -*-


# import modules
import sys
import grass.script as grass


def main():
#def PoupulateClassificationErrors():
    """
    Step ?.? Check Oe/Ce for classifications
    """





##############################################################################
### input:



#    # get classification rasters from options
#    classification_rasters = options['classification_rasters'].split(',')

    classification_rasters=''

    # hardcoded stuff --------------------------------------------------------
    ### classification_rasters=["test_eig_correlation","test_svd_raw_uncentered_unscaled"]
    # hardcoded stuff --------------------------------------------------------

    # if not given then get from g.mlist
    if classification_rasters == '':

        classification_rasters_raw = grass.read_command('g.mlist',\
                                                type = "rast",\
                                                pat = "pareto_classification*") # hardcoded! CHANGE IT!
        classification_rasters = classification_rasters_raw.splitlines()


    # get classification vectors

    #    classification_vectors[x] = "%s_vector" % classification_rasters[x]
    classification_vectors_raw = grass.read_command('g.mlist',\
                                                    type = "vect",\
                                                    pat = "pareto_classification_V___*")
    classification_vectors = classification_vectors_raw.splitlines()


    # thresholds integers
    thresholds_int = [1] + range(10,110,10)
    # thresholds_int = options['thresholds_int']

    # new list
    p_thresholds = []

    # fill-it
    for x in range(0, len(thresholds_int)):
        p_thresholds.append("t%s" % thresholds_int[x])


                        # or: create new list with pareto thresholds
                    #    p_thresholds = thresholds_int
                    #    for x in range(0, len(thresholds_int),1):
                    #            p_thresholds[x] = "t%s" % thresholds_int[x]

    # create new list for...
    pt_n_classifications = p_thresholds + classification_rasters


    # grids from which to pull cats
    group_of_lowres_vector_grid_points_raw = grass.read_command('g.mlist',\
                                        type = "vect",\
                                        pat = "pareto_grid___OVER___*___ON___*points")
    group_of_lowres_vector_grid_points = group_of_lowres_vector_grid_points_raw.splitlines()

### output:
##############################################################################


# loop over lowres_vector_grid_points
    for lowres_vector_grid_points in group_of_lowres_vector_grid_points:


        print "Processing map %s" % lowres_vector_grid_points


        ### for loop ###
        for cR in classification_rasters:

            # control = PC + classification ?
            control = "%s_control" % cR
            control_string = "%s_control_string" % cR
            erroneous_pix = "%s_erroneous_pix" % cR
            coi_pix = "coi_pix"


            # Accurate (=agreement between reference and classified pixel):
            # control= 0 and control_string= accurate

              # Two /accurate/ possibilities:

            # "Reference = NULL"  and  "Classification = NULL"
            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column = control,\
            value = 0,\
            where = "coi_percent is NULL and %s is NULL" % cR)

            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column = control_string,\
            value = "accurate",\
            where = "coi_percent is NULL and %s is NULL" % cR)


            # "Reference is 100 % Burned"  and  "Classification is Burned (=100 %)"
            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column = control,\
            value = 0,\
            where = "coi_percent = 100 and %s is not NULL" % cR)

            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column = control_string,\
            value = "accurate",\
            where = "coi_percent = 100 and %s is not NULL" % cR)


            # Omissions: control = 1  and  control_string = "omission" ; NOTE: t = 1% will have no omission
            # Omissions exists for "Reference Burned %"  >  "Classified Burned %".
              # Comparing high-resolution reference data sets with low-resolution thematic products _only one_ omission possibility because:

              # "Reference Burned %"  >  "Classified Burned %". Classified is always 100 % if Burned, thus:
                # omission exists only where "Reference Burned %" is not NULL  and  "Classified Burned %" is NULL and is equal to:
                  # omission = burned pixels

            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column = control,\
            value = 1,\
            where = "coi_percent is not NULL and %s is NULL" % cR)

            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column = control_string,\
            value = "omission",\
            where = "coi_percent is not NULL and %s is NULL" % cR)

            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column = erroneous_pix,\
            qcolumn = coi_pix,\
            where = "coi_percent is not NULL and %s is NULL" % cR)


            # Commissions: control = 2  and  control_string = "commission" ; NOTE: t = 100% will have no commission
              # Two commission possibilities:

                # a. "Reference Burned %" is NULL  and "Classified Burned %" is not NULL (=100 %)
                # commission = reference pixels (=maximum number of centroids within the low-resolution grid-cell)

            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column=control,\
            value = 2,\
            where = "coi_percent is NULL and %s is not NULL" % cR)

            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column =control_string,\
            value = "commission",\
            where = "coi_percent is NULL and %s is not NULL" % cR)

            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column = erroneous_pix,\
            qcol = "total_pix",\
            where = "coi_percent is NULL and %s is not NULL" % cR)


                # b. "Reference Burned %" is not NULL  and  "Classified Burned %" is not NULL (=100 %)
                # commission = reference pixels - burned pixels

            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column = control,\
            value = 2,\
            where = "coi_percent < 100 and %s is not NULL" % cR)

            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column = control_string,\
            value = "commission",\
            where ="coi_percent < 100 and %s is not NULL" % cR)

            grass.run_command('v.db.update',\
            map = lowres_vector_grid_points,\
            column = erroneous_pix,\
            value = "total_pix - coi_pix",\
            where = "coi_percent < 100 and %s is not NULL" % cR)


    print "\n* Control key values and strings updated for classifications\n"


#  make it both a reusable module and a stand-alone utility
if __name__ == "__main__":
    options, flags = grass.parser()
    main()

