#!/usr/bin/env python
#-*- coding:utf-8 -*-


# import modules
import sys
import grass.script as grass


# Step ?: Export as CSV ######################################################

def main():
#def ExportCSV():
    """
    Export results as Comma Separated Values
    """


#-----------------------------------------------------------------------------
### input:

    # grids from which to pull cats
    group_of_lowres_vector_grid_points_raw =\
     grass.read_command('g.mlist',\
      type = "vect",\
       pat = "pareto_grid___OVER___*___ON___*_points")

    group_of_lowres_vector_grid_points =\
     group_of_lowres_vector_grid_points_raw.splitlines()

### output:

    # variables to use for output naming?
    gisdbase =\
     grass.read_command('g.gisenv',\
      get =  'GISDBASE')

    location_name =\
     grass.read_command('g.gisenv',\
      get = 'LOCATION_NAME')
#-----------------------------------------------------------------------------


    for lowres_vector_grid_points in group_of_lowres_vector_grid_points:

# harcoded -- FIXME ----------------------------------------------------------
        # export final omission, commission errors as csv
        grass.run_command('db.out.ogr',\
        input = lowres_vector_grid_points,\
        format = "CSV",\
        dsn = "/geo/grassdb/spearfish60/R_files/csv_%s"\
         % lowres_vector_grid_points) # make it a short name!
# harcoded -- FIXME ----------------------------------------------------------

#  make it both a reusable module and a stand-alone utility
if __name__ == "__main__":
    options, flags = grass.parser()
    main()

